<template>
    <div class="content-wrapper content-league">

        <page-search v-if="!leagueLoading && !standingsLoading && !matchesLoading"/>

        <!-- <pre>
            {{ league }}
        </pre> -->

        <box v-if="!leagueLoading && !standingsLoading && !matchesLoading">
            <league-tabs
                :image="league && league.img ? league.img : false"
                :name="league && league.name ? league.name : ''"
                icon="nhl"
                :country="league && league.location && league.location.name ? league.location.name : ''"
                :flag="league && league.location && league.location.iso_2 ? league.location.iso_2 : ''"
                :tabs="tabs"
                :allow-sorting="$route.params.tab === 'results'"
                :selected-tab="tab"
            />

            <!-- Standings Tab -->
            <league-standings-list
                :standings="standings"
                :logos="standingsTeamsLogos"
                v-if="!isMatchesTab"
            />
        </box>

        <!-- Next Tab -->
        <league-matches-list
            v-if="currentTabId === 'next' && isMatchesTab && matches && !leagueLoading && !standingsLoading && !matchesLoading"
            :matches="sortedMatches"
            :sort="$route.params.tab === 'results' ? 'oldest' : 'newest'"
        />

        <div class="no-matches" v-else-if="!matchesLoading && !leagueLoading && !standingsLoading && noNextMatches">
            No matches found
        </div>

        <!-- Schedule Tab -->
        <league-matches-list
            v-if="currentTabId === 'schedule' && isMatchesTab && matches && !leagueLoading && !standingsLoading && !matchesLoading && !noScheduleMatches"
            :matches="sortedMatchesResults"
            :sort="$route.params.tab === 'results' ? 'oldest' : 'newest'"
        />

        <div class="no-matches" v-else-if="currentTabId === 'schedule' && noScheduleMatches">
            No matches found
        </div>

        <!-- Results Tab -->
        <league-matches-list
            v-if="currentTabId === 'results' && isMatchesTab && matches && !leagueLoading && !standingsLoading && !matchesLoading"
            :matches="sortedMatchesResults"
            :sort="$route.params.tab === 'results' ? 'oldest' : 'newest'"
        />

        <div class="no-matches" v-else-if="!matchesLoading && !leagueLoading && !standingsLoading && noFinishedMatches">
            No matches found
        </div>

        <loader v-else-if="matchesLoading || leagueLoading || standingsLoading" />
    </div>
</template>

<script>
import { mapGetters, mapActions, mapMutations } from 'vuex'
import moment from 'moment'

import VueRouter from 'vue-router'
import Breadcrumbs from '../components/Breadcrumbs'
import PageSearch from '../components/pageparts/PageSearch'
import Box from '../components/pageparts/box/Box'
import LeagueTabs from '../components/pageparts/league/LeagueTabs'
import LeagueMatchesList from '../components/pageparts/league/tabs/LeagueMatchesList'
import LeagueStandingsList from '../components/pageparts/league/tabs/LeagueStandingsList'
import Loader from '../components/Loader'

export default {
    name: 'League',
    data() {
        return {
            tabs: [
                { id: 'next', name: 'Next Matches', disabled: false },
                { id: 'schedule', name: 'Schedule', disabled: false },
                { id: 'results', name: 'Results', disabled: false },
                { id: 'standings', name: 'Standings', disabled: false },
            ],
            sortedMatches: [],
            sortedMatchesScheduled: [],
            sortedMatchesFinished: [],
            sortedMatchesResults: [],
            matchesLoading: true,
            matchesFinishedLoading: true,
            leagueLoading: true,
            standingsLoading: true
        }
    },
    props: {
        tab: String,
        default: 'next'
    },
    computed: {
        isMatchesTab() {
            return this.tab === 'next' || this.tab === 'schedule' || this.tab === 'results' || this.tab === undefined
        },
        currentTabId() {
            if(this.tab === undefined) return 'next'
            return this.tab.toLowerCase()
        },
        noNextMatches() {
            return this.currentTabId === 'next' && !this.matchesLoading && this.sortedMatches.length
        },
        noFinishedMatches() {
            return this.currentTabId === 'results' && !this.matchesFinishedLoading && this.sortedMatchesFinished.length
        },
        noScheduledMatches() {
            return this.currentTabId === 'schedule' && !this.matchesLoading && (this.sortedMatchesScheduled.length===0)
        },
        noScheduleMatches() {
            return this.currentTabId === 'schedule' && (this.sortedMatchesScheduled.length===0)
        },
        ...mapGetters(['standings', 'matches', 'matchesFinished', 'league', 'standingsTeamsLogos']),
    },
    methods: {
        ...mapActions(['fetchStandings', /*'fetchMatches'*/, 'fetchMatchesFinished','fetchLeagueAndMatches' /*'fetchLeague'*/, /*'fetchStandingsTeamsLogos'*/]),
        fetchData() {
            this.standingsLoading = this.matchesLoading = this.leagueLoading = true
          /*  this.fetchStandings(this.$route.params.leagueId).finally(() => {
                this.standingsLoading = false
                this.$forceUpdate()
            })*/
            this.fetchLeagueAndMatches(this.$route.params.leagueId).finally(() => {
                this.matchesLoading = false
                this.leagueLoading = false
                this.$root.$emit('setLeagueName', this.league.name);
                this.$root.$emit('setLeagueId', this.league.id);
                this.$forceUpdate()
            })
            this.fetchMatchesFinished(this.$route.params.leagueId).finally(() => {
                this.matchesFinishedLoading = false
                this.$forceUpdate()
            })
        /*    this.fetchLeague(this.$route.params.leagueId).finally(() => {
                this.leagueLoading = false
                this.$root.$emit('setLeagueName', this.league.name);
                this.$root.$emit('setLeagueId', this.league.id);
                this.$forceUpdate()
            })*/
           // this.fetchStandingsTeamsLogos(this.$route.params.leagueId)
        }
    },
    watch: {
        matches(val) {

            this.sortedMatches = [];
            this.sortedMatchesScheduled = [];
            for (let date in val) {
                this.sortedMatches.push({
                    date,
                    data: val[date]
                });

                this.sortedMatchesScheduled.push({
                    date,
                    data: val[date]
                });
            }
            const dateFormat = 'DD MMM YYYY';
            this.sortedMatches.sort((a, b) => {
                return moment(a.date, dateFormat, true).format() < moment(b.date, dateFormat, true).format() ? -1 : 1
            });

            //return only events with bets
            this.sortedMatches = this.sortedMatches.map(function (matches) {
                    let data =   matches.data.filter(function (match) {
                                    return match.event.bets.length;
                    });

                return {data:data,date:matches.date}
            });

            //return matches with events
            this.sortedMatches = this.sortedMatches.filter(function (matches) {

                return matches.data.length
            });

            this.sortedMatchesScheduled.sort((a, b) => {
                return moment(a.date, dateFormat, true).format() < moment(b.date, dateFormat, true).format() ? -1 : 1
            });

            //return only events with bets
            this.sortedMatchesScheduled = this.sortedMatchesScheduled.map(function (matches) {
                let data =   matches.data.filter(function (match) {
                    return ((match.event.bets.length===0) && moment(match.start_date, 'YYYY-MM-DDTHH:mm:ss').isAfter(moment().format()));
                });

                return {data:data,date:matches.date}
            });

            this.sortedMatchesScheduled = this.sortedMatchesScheduled.filter((matches) => {
                return matches.data.length
            })
        },
        matchesFinished(val) {
            this.sortedMatchesFinished = [],
            this.sortedMatchesResults = []
            for (let date in val) {
                this.sortedMatchesFinished.push({
                    date,
                    data: val[date]
                });

                this.sortedMatchesResults.push({
                    date,
                    data: val[date]
                });
            }

            const dateFormat = 'DD MMM YYYY';
            this.sortedMatchesFinished.sort((a, b) => {
                return moment(a.date, dateFormat, true).format() < moment(b.date, dateFormat, true).format() ? -1 : 1
            })
            this.sortedMatchesResults.sort((a, b) => {
                return moment(a.date, dateFormat, true).format() < moment(b.date, dateFormat, true).format() ? 1 : -1
            })
        },
        "$route.params.leagueId": function() {
            this.fetchData()
        },
        standings(val){
            this.standingsLoading = false
            this.$forceUpdate()
        }
    },
    mounted() {
        this.fetchData()
    },
    components: {
        Loader,
        Breadcrumbs,
        PageSearch,
        Box,
        LeagueTabs,
        LeagueMatchesList,
        LeagueStandingsList,
    },
}
</script>

<style scoped>
    .no-matches {
        font-size: 18px;
        text-align: center;
        padding: 24px 12px;
    }
</style>
